if not (Klappa) then return; end;
local _G = getfenv(0);

local Klappa = Klappa;
local AceOO = AceLibrary("AceOO-2.0");

Klappa.Button = AceOO.Class("AceEvent-2.0");

function Klappa.Button.prototype:init(idx, type, id, bar)
	Klappa.Button.super.prototype.init(self);
	Klappa:Debug("Base class, index:");
	Klappa:Debug(idx);
	self.index = idx;
	self.type = type;
	self.id = id;
	self.bar = bar;
	self.barid = bar.index;
	self.isPopup = false;
	self.outOfRange = false;
	self.showgrid = 0;
	self.flashing = 0;
	self.flashtime = 0;
	self.elapsed = 0;
end

function Klappa.Button.prototype:ButtonProperties()
	local button = self.button;
	local name = button.name;
	
	--Create textures
	button.icon = button:CreateTexture(nil, "BACKGROUND");
	button.icon:SetPoint("TOPLEFT", button, "TOPLEFT", 3, -3);
	button.icon:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT",  -3, 3);
	button.icon:SetTexCoord(0.08, 0.92, 0.08, 0.92);
	
	button:SetNormalTexture("");
	
	local oldTexture = _G[("%sNormalTexture"):format(name)];
	oldTexture:Hide();
	button.normalTexture = button:CreateTexture(("%sBTNT"):format(name));
	button.normalTexture:SetAllPoints(oldTexture);
	
	button.pushedTexture = button:GetPushedTexture();
	button.highlightTexture = button:GetHighlightTexture();
	
	
	button.cooldown = _G[("%sCooldown"):format(name)];
	button.border = _G[("%sBorder"):format(name)];
	button.macroName = _G[("%sName"):format(name)];
	button.hotkey = _G[("%sHotKey"):format(name)];
	button.count = _G[("%sCount"):format(name)];
	button.flash = _G[("%sFlash"):format(name)];
	button.flash:Hide();
	
	self:ApplyStyle();
	
	-- Register Buttons
	button:RegisterForDrag("LeftButton", "RightButton");
	button:RegisterForClicks("AnyUp");

	--Set scripts
	button:SetScript("OnDragStart", function() self:ButtonDrag(); end);
	button:SetScript("PostClick", function() self:UpdateState(); end);
	button:SetScript("OnEvent", function() self:OnEventFunc(event); end);
	button:SetScript("OnUpdate", function() self:OnUpdate(arg1); end);
	button:SetScript("OnReceiveDrag", function() self:ButtonDrop(); end );
	--self.button:SetScript("OnAttributeChanged", function() Klappa:OnAttributeChangedFunc(self.button);end);
	
	--Register general events
	self:RegisterGeneralEvents();
	
	--Set Attributes
	button:SetAttribute("type", "action");
	button:SetAttribute("checkselfcast", true);
	button:SetAttribute("useparent-unit", true);
	
	self:UpdateButton(true);
	--self:UpdateHotkeys();
end











